# coding: utf-8

"""
    AccessibleTranslator SDK API

    Official SDK API for AccessibleTranslator - automated cognitive accessibility

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from accessibletranslator.models.function_info import FunctionInfo
from accessibletranslator.models.transformation_info import TransformationInfo
from typing import Optional, Set
from typing_extensions import Self

class TransformationsResponse(BaseModel):
    """
    Response model for available transformations
    """ # noqa: E501
    transformations: List[TransformationInfo]
    total_transformations: StrictInt
    functions: List[FunctionInfo]
    total_functions: StrictInt
    usage_note: StrictStr
    __properties: ClassVar[List[str]] = ["transformations", "total_transformations", "functions", "total_functions", "usage_note"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransformationsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in transformations (list)
        _items = []
        if self.transformations:
            for _item_transformations in self.transformations:
                if _item_transformations:
                    _items.append(_item_transformations.to_dict())
            _dict['transformations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in functions (list)
        _items = []
        if self.functions:
            for _item_functions in self.functions:
                if _item_functions:
                    _items.append(_item_functions.to_dict())
            _dict['functions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransformationsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "transformations": [TransformationInfo.from_dict(_item) for _item in obj["transformations"]] if obj.get("transformations") is not None else None,
            "total_transformations": obj.get("total_transformations"),
            "functions": [FunctionInfo.from_dict(_item) for _item in obj["functions"]] if obj.get("functions") is not None else None,
            "total_functions": obj.get("total_functions"),
            "usage_note": obj.get("usage_note")
        })
        return _obj


